Subject: bug#25216: closed (Re: bug#25216: 26.0.50 [regression]; Curly quotes are not found in some sizes of ‘Terminus’font)

From: [email-masked] (GNU bug Tracking System)
Date: Mon, 25 Nov 2019 16:17:02 +0000

Your bug report

#25216: 26.0.50 [regression]; Curly quotes are not found in some sizes of ‘Terminus’ font

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
25216: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=25216
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#25216: 26.0.50 [regression]; Curly quotes are not found in some sizes of ‘Terminus’ font
From: Eli Zaretskii <[email-masked]>
To: Dmitry Alexandrov <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Mon, 25 Nov 2019 18:16:40 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Dmitry Alexandrov <[email-masked]>
> Cc: [email-masked],  [email-masked]
> Date: Wed, 20 Nov 2019 18:01:48 +0300
> 
> Eli Zaretskii <[email-masked]> wrote:
> >> > There was no response to this -- was any further progress made?
> >> 
> >> On my side: sorry, no.  I am fine with the workaround:
> >> 
> >> 	Emacs.fontBackend: xft
> >> 
> >> (in ~/.Xresources).
> >
> > Could you try the master branch, after making sure you have HarfBuzz installed?  The xft font backend is going to be much less important starting with Emacs 27, so I'd like to know whether this problerm exists with HarfBuzz
> 
> Yes, the problem is still here, symptoms are the same, except that Terminus is now loaded via harfbuzz:
> 
> 	xfthb:-xos4-Terminus-normal-normal-normal-*-18-*-*-*-c-100-iso10646-1
> 	   ^^
> 
> The same workaround works as well:
> 
> 	Emacs.fontBackend: xfthb

I've built the latest version 4.48 of the Terminus font on MS-Windows
and tried it with Emacs 27.  I couldn't reproduce the problem reported
with the xft or xfthb font backends: no matter what size of the font I
tried, the curly quote characters came from the same font.  I do see
that, since this font is bitmapped, i.e. not TrueType, Emacs on
Windows uses the GDI font backend to display it, not the default
HarfBuzz backend.

So I think what you see is something specific to the libxft2 library.
And since this discussion identified at least 2 workarounds: either
customize the fontset, or force the single xft backend in .Xresources,
I think this bug can be closed now.

Thanks.

Subject: 26.0.50 [regression]; Curly quotes are not found in some sizes of‘Terminus’ font
From: Dmitry Alexandrov <[email-masked]>
To: [email-masked]
Date: Sat, 17 Dec 2016 04:03:07 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

GNU Emacs 26.0.50.1 (x86_64-unknown-linux-gnu)
Repository revision: 6bf83218314db1c63ce34564edfb994d9431b28a
Debian GNU/Linux 8.6 Jessie
xfonts-terminus 4.40-2 as shipped in Debian

Steps to reproduce:

   $ emacs --quick --font '-*-terminus-medium-r-*-*-20-*-*-*-*-*-*-*'

Find some document with curly quotes: ‘’ and “”.  GNU Emacs Manual (‘<f1> r’) uses them heavily, for instance.

It looks wrong:

‘C-u C-x =’ says that instead of Terminus ‘x:-misc-fixed-medium-r-normal--20-200-75-75-c-100-iso10646-1’ font is used for rendering quotes.  When I request 24th size, I got yet another font — ‘x:-efont-fixed-medium-r-normal--24-240-75-75-c-240-iso10646-1’.

In a strange way there is no such a problem with some other sizes:

   $ emacs --quick --font '-*-terminus-medium-r-*-*-16-*-*-*-*-*-*-*'

is okay, for example.  ‘C-u C-x =’ says that ‘xft:-xos4-Terminus-normal-normal-normal-*-16-*-*-*-c-80-iso10646-1’ is used in that case.

The reason is *not* that Terminus just does not have these glyphs — it does.  Moreover — GNU Emacs 24.4.1 finds and renders them correctly:

   $ emacs24 --quick --font '-*-terminus-medium-r-*-*-20-*-*-*-*-*-*-*'